# Copyright 2009 Canonical Ltd.
#
# This file is part of desktopcouch.
#
#  desktopcouch is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License version 3
# as published by the Free Software Foundation.
#
# desktopcouch is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with desktopcouch.  If not, see <http://www.gnu.org/licenses/>.
"""Communicate with CouchDB."""

import urllib2
import json
import logging

def replicate_to(port, src_name, dst_host, dst_port, dst_name):
    """A simple easiest-possible replication instruction for couchdb.  It's
    almost certainly wrong for us."""

    dst_url = u"http://%(dst_host)s):%(dst_port)d/%(dst_name)s" % locals()
    doc_data = dict(source_database=src_name.encode("utf8"),
            target_database=dst_url.encode("utf8"))

    document = json.dumps(doc_data)  # json doesn't mention Unicode.

    req = urllib2.Request("http://localhost:%d/_replicate" % (port,), document)
    
    try:
        conn = urllib2.urlopen(req)
        logging.info("couchdb request resulted in %r", conn.read())
    except:
        logging.exception("can't talk to couchdb.")
        raise
