"""testing desktopcouch/local_files.py module"""

import testtools
import os

class TestLocalFiles(testtools.TestCase):
    """Testing that local files returns the right things"""
    def test_all_files_returned(self):
        "Does local_files list all the files that it needs to?"
        import desktopcouch.local_files
        for required in ["FILE_LOG", "FILE_INI", "FILE_PID", "FILE_STDOUT",
          "FILE_STDERR", "DIR_DB", "COUCH_EXE", "COUCH_EXEC_COMMAND"]:
            self.assertTrue(required in dir(desktopcouch.local_files))

    def test_file_locations(self):
        "Are the files in local_files actually correct?"
        # Only test one file; if one's right the others should be too
        import desktopcouch.local_files
        thisfolder = os.path.split(__file__)[0]
        tmpfolder = os.path.join(thisfolder, "..", "..", "..", "..", "tmp")
        pidfile = os.path.join(tmpfolder, "desktop-couchdb.pid")
        flatpidfile = os.path.realpath(pidfile)
        self.assertEqual(flatpidfile, desktopcouch.local_files.FILE_PID)
    
    
